#ifndef BMSBEL_REGIST_ARRAY_H_
#define BMSBEL_REGIST_ARRAY_H_

#include <string>
#include <utility>

#include "bms_define.h"
#include "bms_word.h"

// -- BmsRegistArray -----------------------------------------------------
class BmsRegistArray {
public:
  // str ̍\ɂĂ邩ǂ
  // #???@@ value ł [??? => name] [@@ => 00-ZZ] ǂ`FbN
  static bool CheckConstruction( const std::string& name, const std::string& str );

public:
  explicit BmsRegistArray( void );
  explicit BmsRegistArray( const std::string& name );

  ~BmsRegistArray();

  const std::string& GetName( void ) const;
  void SetName( const std::string& name );

  unsigned int GetExistCount( void ) const;

  bool IsExist( BmsWord pos ) const;
  bool IsNotExist( BmsWord pos ) const;

  // QƂ̂
  const std::string& At( BmsWord pos ) const;
  const std::string& operator []( BmsWord pos ) const;

  void Set( BmsWord pos, const std::string& value );

  void DeleteAt( BmsWord pos );

  std::string ToString( void ) const;

private:
  std::string                   name_;
  std::pair<bool, std::string>* array_;
};

#endif // BMSBEL_REGIST_ARRAY_H_
